
let rec wait n =
  if n = 0
  then ()
  else
    try
      let _,_,_ = Unix.select [] [] [] 0.1 in
      ()
    with _ ->
      wait (n-1)

let _ =
  if Array.length Sys.argv < 4 then begin
    prerr_endline "Usage: ./player map lambda_man.gcc ghost1.ghc [ghost2.ghc...]";
    exit 2
  end;
  let n_ghost = Array.length Sys.argv - 3 in
  let ghosts = Array.sub Sys.argv 3 n_ghost in
  let buf = Buffer.create 100 in
  let ppf = Format.formatter_of_buffer buf in
  let state =
    Run_world.init_state
      ppf
      ~map:(Sys.argv.(1))
      ~lambda_file:(Sys.argv.(2))
      ~ghost_files:ghosts in
  Display.open_display state.world 30 ;
  let state = ref state in
  while true do
    match Run_world.run_step !state with
    | End score ->
       Printf.printf "score: %i\n%!" score;
       Display.close_display ();
       exit 0
    | Continue (st, some_move) ->
       let s = Buffer.contents buf in
       Buffer.clear buf;
       if some_move
       then
         (if s <> "" then Display.set_text s;
          let () = Display.refresh !state.Run_world.world in
          wait 100);
       state := st
  done
